Attribute VB_Name = "RegUtil"
Option Explicit

Public Const FIND_KEY = &H1
Public Const FIND_VALUE = &H2
Public Const FIND_DATA = &H3
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const KEY_NOTIFY = &H10
Public Const READ_CONTROL = &H20000
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_LINK = &H20
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const SYNCHRONIZE = &H100000
Public Const KEY_QUERY_VALUE = &H1
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const KEY_EXECUTE = (KEY_READ)
Public Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Public Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Public Const READ_WRITE = 2
Public Const ERROR_SUCCESS = 0&
Public Const ERROR_NO_MORE_ITEMS = 259&
Public Const MAX_PATH = 260

Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Type ResultSet
    varEntryList() As Variant
    lngEntryCount As Long
End Type

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
    
Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias _
    "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, _
    ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, _
    ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long

Declare Function RegQueryValueEx Lib "advapi32.dll" Alias _
    "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
    ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
    
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias _
    "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, _
    ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long

Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias _
    "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long

Public udtResults As ResultSet


Public Sub RegFind(ByVal strSearchItem As String, ByVal FindItem As Integer, _
        blnFound As Boolean)
On Error GoTo RegFind_Error

Dim lngResult As Long
Dim hKey As Long
Dim phkResult As Long
Dim lpSubKey As String

    'Assume False
    blnFound = False

    'Prepare result set
    Erase udtResults.varEntryList()
    ReDim udtResults.varEntryList(0)
    udtResults.lngEntryCount = 0
   
    'Start at root
    lpSubKey = ""

    Select Case FindItem
        Case FIND_KEY
            lngResult = RegOpenKeyEx(HKEY_CLASSES_ROOT, lpSubKey, &H0, KEY_READ, phkResult)
            If lngResult = ERROR_SUCCESS Then
                Call RegFindKey(phkResult, UCase$(strSearchItem), lpSubKey)
            End If
            blnFound = udtResults.lngEntryCount > 0
            lngResult = RegCloseKey(phkResult)
            If lngResult <> ERROR_SUCCESS Then
                MsgBox "Can't close the key or key already closed"
            End If
        Case FIND_VALUE
        Case FIND_DATA
        Case Else
            Err.Raise 500000, , "Invalid FIND criteria."
    End Select
    
    
Exit Sub
RegFind_Error:

    MsgBox Err.Description, , "RegArbiter Error"
    
End Sub

Private Sub RegFindKey(ByVal hKey As Long, ByVal strSearchKey As String, lpSubKey As String)
On Error GoTo RegFindKey_Error

Dim lngResultOpen As Long
Dim phkResult As Long
Dim lpSubKeyOpen As String

Dim lngResult As Long
Dim dwIndex As Long
Dim lpName As String
Dim lpcbName As Long
Dim lpClass As String
Dim lpcbClass As Long
Dim lpftLastWriteTime As FILETIME
Dim Keys() As String
Dim lngKeyCount As Long

    'Set up some parameters with preinitialized values dictated by the API docs.
    dwIndex = 0&
    lpName = String(MAX_PATH + 1, " ")
    lpClass = String(MAX_PATH + 1, " ")
    lpcbClass = MAX_PATH + 1
    lpcbName = MAX_PATH + 1
    
    'Hold all key names
    Erase Keys()
    ReDim Keys(0)
    lngKeyCount = 0
    
    'Iterate until we have no more keys
    Do
    
        'Walk the keys below the current subkey
        lngResult = RegEnumKeyEx(hKey, dwIndex, lpName, lpcbName, 0&, _
            lpClass, lpcbClass, lpftLastWriteTime)
        'Test for a match
        If (InStr(UCase$(Left$(lpName, lpcbName)), strSearchKey)) Then
            'A match!  Add to our global list
            udtResults.lngEntryCount = udtResults.lngEntryCount + 1
            ReDim Preserve udtResults.varEntryList(udtResults.lngEntryCount)
            If lpSubKey = "" Then
                udtResults.varEntryList(udtResults.lngEntryCount - 1) = "HKEY_CLASSES_ROOT\" & _
                   Left$(lpName, lpcbName)
            Else
                udtResults.varEntryList(udtResults.lngEntryCount - 1) = "HKEY_CLASSES_ROOT\" & _
                   lpSubKey & "\" & Left$(lpName, lpcbName)
            End If
        End If
        
        'Recurse
        If lngResult = ERROR_SUCCESS Then
            If lpSubKey = "" Then
                lpSubKeyOpen = Left$(lpName, lpcbName)
            Else
                lpSubKeyOpen = lpSubKey & "\" & Left$(lpName, lpcbName)
            End If
            lngResultOpen = RegOpenKeyEx(HKEY_CLASSES_ROOT, lpSubKeyOpen, &H0, KEY_READ, phkResult)
            If lngResultOpen = ERROR_SUCCESS Then
                Call RegFindKey(phkResult, strSearchKey, lpSubKeyOpen)
                lngResultOpen = RegCloseKey(phkResult)
            End If
        End If
        
        'Absolutely necessary to reinitialize parameters
        lpName = String(MAX_PATH + 1, " ")
        lpClass = String(MAX_PATH + 1, " ")
        lpcbClass = MAX_PATH + 1
        lpcbName = MAX_PATH + 1
        dwIndex = dwIndex + 1&
        
    Loop While lngResult = ERROR_SUCCESS
        
Exit Sub
RegFindKey_Error:

    'Something went wrong, close the Registry and get out!
    lngResult = RegCloseKey(hKey)
        
End Sub
